'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.generator = undefined;

var _random2 = require('lodash/random');

var _random3 = _interopRequireDefault(_random2);

var _sample2 = require('lodash/sample');

var _sample3 = _interopRequireDefault(_sample2);

var _result2 = require('lodash/result');

var _result3 = _interopRequireDefault(_result2);

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _uuid = require('../tools/uuid');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createFaker = function createFaker() {
    // eslint-disable-next-line no-console
    console.warn("Faker has been stripped from the production build");
    return false;
};
if (process.env.NODE_ENV !== 'production') createFaker = function createFaker() {
    return require('faker');
};

/* Generate some fake information based on the type of a field.
 * If the field type is an object, then we handle first the
 * __faker case, and second the __pattern case.
 *
 * if the __faker property is set, generate fake information
 * using fakerjs.
 *
 * If the __pattern property is set, split the property by the
 * delimiter "|" and select one of the resulting strings
 * */
var generator = exports.generator = function generator(fakerInstance) {
    return function (type) {
        if ((typeof type === 'undefined' ? 'undefined' : _typeof(type)) === 'object') {
            var __type = type.__type,
                __faker = type.__faker,
                __pattern = type.__pattern;


            if (__faker) {
                var faker = fakerInstance || createFaker(); // check if a faker instance has been provided in config
                if (!faker) return generator(fakerInstance)(__type);
                return (0, _result3.default)(faker, __faker);
            }

            if (__pattern) {
                var options = __pattern.split("|");
                var result = (0, _sample3.default)(options);
                switch (type) {
                    case Number:
                    case "number":
                    case "integer":
                        {
                            return parseInt(result);
                        }
                }
                return result;
            }

            return generator(fakerInstance)(__type);
        } else {
            switch (type) {
                case String:
                case "string":
                    {
                        return (0, _uuid.v4)().substring(0, 10);
                    }

                case Number:
                case "integer":
                case "number":
                    {
                        return (0, _random3.default)(-10000, 10000);
                    }

                case "float":
                    {
                        return (0, _random3.default)(-10000, 10000, true);
                    }

                case Boolean:
                case "boolean":
                    {
                        return !!(0, _random3.default)(1);
                    }
            }
        }
    };
};