'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createLogger = undefined;

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A logger utility to help debug and follow individual requests
 */
var createLogger = exports.createLogger = function createLogger(name) {
    var group = [];
    var time = Date.now();

    return {
        add: function add(key, value) {
            return group.push({ key: key, value: value });
        },
        print: function print() {
            /* eslint-disable */
            if (typeof console.groupCollapsed === 'function') console.groupCollapsed(name + ' [' + (Date.now() - time) / 1000 + 's]');
            (0, _forEach3.default)(group, function (_ref) {
                var key = _ref.key,
                    value = _ref.value;

                if (typeof console.groupCollapsed === 'function') console.groupCollapsed(key);
                console.log(value);
                if (typeof console.groupEnd === 'function') console.groupEnd();
            });
            if (typeof console.groupEnd === 'function') console.groupEnd();
            /* eslint-enable */
        }
    };
};