"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * A public helper function that adds a union description property
 * to a Data Model.
 */
var union = exports.union = function union(UnionDescription) {
    if (!UnionDescription.schemaAttribute) throw new Error("A union requires a schemaAttribute");

    return _extends({}, UnionDescription, {
        _unionDataType: true
    });
};

/**
 * An error type that denotes a response containing
 * GraphQL errors
 */
var GraphQLError = exports.GraphQLError = function GraphQLError(message, errors) {
    _classCallCheck(this, GraphQLError);

    this.message = message || "The GraphQL server responded with errors.";
    this.graphQLErrors = errors;
};